const fs = require('fs')
const path = require('path')
const resolve = require('resolve/sync');

function resolveAxiosPath() {
  var res = resolve('axios', { basedir: __dirname });
  return path.dirname(res)
}

function patchBrowserIndex(axiosPath) {
  const patchPath = path.resolve(axiosPath, 'lib/platform/browser/index.js')

  // TODO: 验证axios版本
  // TODO：确定在pnpm下，如果存在多个axios版本会怎样？

  const contentPath = path.resolve(__dirname, './patch-content.txt')
  const patchContent = fs.readFileSync(contentPath)
  
  console.log('patched axios file:', patchPath)
  fs.writeFileSync(patchPath, patchContent)
}

function patchAxiosPackageJson(axiosPath) {
  const packagePath = path.resolve(axiosPath, 'package.json')

  const contentObj = require(packagePath)

  const exportDot = contentObj.exports['.']

  exportDot.browser.require = './index.js'
  exportDot.default.require = './index.js'

  fs.writeFileSync(packagePath, JSON.stringify(contentObj), {encoding: 'utf8'})
}

function patchAxios() {

  const axiosPath = resolveAxiosPath()

  patchBrowserIndex(axiosPath)
  
  patchAxiosPackageJson(axiosPath)
}

patchAxios()